#include <bits/stdc++.h>
using namespace std;

int main(){
ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
long long n, m; cin >> n >> m;
if ( n == 3 ){
    cout << 2*m + m/2 + 1;
}
else{
    cout << (2*m*n + m + n) / 3;
}

return 0;
}